#include <vector>
#include <set>
#include <iostream>

using namespace std;

vector<set<int>> getSubsetsOfOneToN(int n){
	vector<set<int>> v;
	set<int> s;
	if (n<=0){
		v.push_back(s);
		return v;
	}
	else{
		v = getSubsetsOfOneToN(n-1); // all subsets without n
		int freezed_size = v.size();
		for (int i=0; i<freezed_size; i++){
			s = v[i];
			s.insert(n);
			v.push_back(s);
		}
		return v;
	}
}

void print_set(const set<int>& s){
	for (set<int>::iterator itr = s.begin(); itr != s.end(); itr++)
		cout << *itr << " ";

	cout << endl;
}

int main(){
	for (int i= 1; i<5; i++){
		cout << "substes of {1.." << i << "}:" << endl;
		vector<set<int>> subsets = getSubsetsOfOneToN(i);
		for (auto itr=subsets.begin(); itr<subsets.end(); itr++)
			print_set(*itr);
	}

}



